<template>
	<div class="sys-user-container">
		<el-row>
			<el-col :span="3">
				<el-collapse v-model="activeName">
					<el-collapse-item title="设备控制" name="1">
						<el-card class="box-card" shadow="hover">
							<el-switch v-model="state.boRunningState" active-text="" inactive-text="程序服务"
								@change="handleSwitchChange('boRunningState', $event)"></el-switch>
						</el-card>
						<el-card class="box-card" shadow="hover" style="margin-top: 3px;">
							<el-switch v-model="state.boOffline" active-text="" inactive-text="脱机模式"
								@change="handleSwitchChange('boOffline', $event)"></el-switch>
						</el-card>
						<el-card class="box-card" shadow="hover" style="margin-top: 3px;">
							<el-switch v-model="state.boRefresh" active-text="" inactive-text="自刷新"
								@change="handleSwitchChange('boRefresh', $event)"></el-switch>
						</el-card>
						<!-- <el-card class="box-card" shadow="hover" style="margin-top: 3px;">
							<el-switch v-model="state.boDemo" active-text="" inactive-text="演示模式"
								@change="handleSwitchChange('boDemo', $event)"></el-switch>
						</el-card>
						<el-card class="box-card" shadow="hover" style="margin-top: 3px;">
							<el-switch v-model="state.boDrumReversal" active-text="" inactive-text="滚动反转"
								@change="handleSwitchChange('boDrumReversal', $event)"></el-switch>
						</el-card> -->
						<el-card class="box-card" shadow="hover" style="margin-top: 3px;">
							<el-switch v-model="state.boOutLock" active-text="" inactive-text="出库锁定"
								@change="handleSwitchChange('boOutLock', $event)"></el-switch>
						</el-card>
						<el-card class="box-card" shadow="hover" style="margin-top: 3px;">
							<el-switch v-model="state.boEnterLock" active-text="" inactive-text="入库锁定"
								@change="handleSwitchChange('boEnterLock', $event)"></el-switch>
						</el-card>
					</el-collapse-item>

					<el-collapse-item title="堆垛机" name="2">
						<div style="overflow-x: auto;white-space: nowrap;">
							<el-card v-for="(stacker, index) in stackers" :key="index" class="box-card" shadow="hover">
								<el-switch v-model="stacker.isConn" :inactive-text="`${stacker.text}`"
									disabled></el-switch>
							</el-card>
						</div>
					</el-collapse-item>

					<el-collapse-item title="输送线" name="3">
						<el-card v-for="(conveyor, index) in conveyors" :key="index" class="box-card" shadow="hover">
							<el-switch v-model="conveyor.isConn" :inactive-text="`${conveyor.text}`"
								disabled></el-switch>
						</el-card>
					</el-collapse-item>
				</el-collapse>
			</el-col>
			<el-col :span="21">
				<div class="card-page">
					<el-button type="primary" :plain="floorStates.isPlain1"
						@click="floorTogglePlain(1)">一层平面</el-button>
					<el-button type="primary" :plain="floorStates.isPlain2"
						@click="floorTogglePlain(2)">四层平面</el-button>
					<!-- <el-button type="primary" :plain="floorStates.isPlain3"
						@click="floorTogglePlain(3)">三层平面</el-button> -->
				</div>
				<div style="margin: 40px; height: 50%;">
					<div v-if="floorNum === 1" class="grid-container-line">
						<div v-for="cell in cellsDataLine" :key="cell.Id">
							<div v-if="cell.IsShow === 0" class="grid-item-line">
								<div class="grid-item-line-end">
									{{ cell.EndLocat }}
								</div>
								<div class="grid-item-line-box" :style="{ marginTop: cell.BoxHeight + 'px' }">
									{{ cell.LineCode }}
								</div>
								<div :class="[{ 'grid-item-line-child2': cell.LineCode === '01' }, { 'grid-item-line-child': cell.LineCode !== '01' }]"></div>
							</div>
						</div>
					</div>
					<div v-if="floorNum !== 1" class="grid-container-line">
						<div v-for="cell in cellsDataLine" :key="cell.Id">
							<div v-if="cell.IsShow === 0 && (cell.LineCode==='05' || cell.LineCode==='06')" class="grid-item-line">
								<div class="grid-item-line-end">
									{{ cell.EndLocat }}
								</div>
								<div class="grid-item-line-box" :style="{ marginTop: cell.BoxHeight + 'px' }">
									{{ cell.LineCode }}
								</div>
								<div class="grid-item-line-child3"></div>
							</div>
						</div>
					</div>
					<div :class="[{ 'grid-container': floorNum === 1 }, { 'grid-container2': floorNum !== 1 }]">
						<div v-for="cell in cellsData" :key="cell.Id">
							<div v-if="cell.IsShow === 0"
								:class="['grid-item', { 'active': cell.IsUse === 1 }, { 'active2': cell.IsUse === 2 }, { 'active3': cell.IsUse === 3 }]">
								<div>{{ cell.Code }}</div>
							</div>
						</div>
					</div>
				</div>
			</el-col>
		</el-row>
	</div>
</template>

<script lang="ts" setup>
import { ref, reactive, onMounted } from 'vue';
import { listStatus, listPosition } from '/@/api/wcs/wcsPlc';
import { signalR } from './signalR';
import { cellsDataLine, cellsDataOne, cellsDataTwo, cellsDataThree } from './data';
import { ElMessage } from "element-plus";

const state = ref<any>({});
const stackers = ref<any>({});
const conveyors = ref<any>({});
// 查询状态
const handleQuery = async () => {
	var res = await listStatus();
	state.value = res.data.result.modService;
	stackers.value = res.data.result.listPlc.filter(s => s.type == 0);
	conveyors.value = res.data.result.listPlc.filter(s => (s.type == 1|| s.type == 4));

	var res2 = await listPosition();
	res2.data.result.forEach(s => {
		if (s.type == 0) {
			// 更新堆垛机数据
			const foundCell = cellsDataLine.value.find(cell => cell.Code === s.stationNum);
			if (foundCell) {
				//修改高度
				foundCell.BoxHeight = s.boxHeight;
				foundCell.EndLocat = s.endLocat;
			}
		}
		else if (s.type == 1) {
			// 更新输送线数据
			updateCellData(cellsDataOne.value, s);
			updateCellData(cellsDataTwo.value, s);
			updateCellData(cellsDataThree.value, s);
		}
	});
};
handleQuery();

//连接signalR 监听变更
onMounted(async () => {
	signalR.off('PublicPlcConn');
	signalR.on('PublicPlcConn', (data: any) => {
		console.log(data)
		if (data.type === 0) {
			// 替换 stackers 中的相应项
			const index = stackers.value.findIndex(item => item.id === data.id);
			if (index !== -1) {
				stackers.value[index] = data;
			}
		} else if (data.type === 1 || data.type === 4) {
			// 替换 conveyors 中的相应项
			const index = conveyors.value.findIndex(item => item.id === data.id);
			if (index !== -1) {
				conveyors.value[index] = data;
			}
		}
		console.log(stackers.value[0].isConn)
	});
	signalR.off('UpdateService');
	signalR.on('UpdateService', (data: any) => {
		state.value = data;
		if (data.error) {
			ElMessage({
				message: data.error,
				type: "error",
			});
		}
	});
	signalR.off('PublicPosition');
	signalR.on('PublicPosition', (data: any) => {
		if (data.type == 1) {
			// 更新输送线数据
			updateCellData(cellsDataOne.value, data);
			updateCellData(cellsDataTwo.value, data);
			updateCellData(cellsDataThree.value, data);
		}
		else if (data.type == 0) {
			// 更新堆垛机数据
			updateStacker(data)
			// const foundCell = cellsDataLine.value.find(cell => cell.Code === data.stationNum);
			// if (foundCell) {
			// 	//修改高度
			// 	foundCell.BoxHeight = data.boxHeight;
			// }
		}
	});
});
const handleSwitchChange = (field: string, value: boolean) => {
	const param = { [field]: value };
	signalR.invoke('UpdateService', param);
};
//更新堆垛机
// updateStacker({ stationNum: '10', boxHeight: 200 })
function updateStacker(data: any) {
	debugger;
	const foundCell = cellsDataLine.value.find(cell => cell.Code === data.stationNum);
	if (foundCell) {
		foundCell.EndLocat = data.endLocat;
		const startHeight = foundCell.BoxHeight;
		const targetHeight = data.boxHeight;
		const duration = 1000; // 动画持续时间（毫秒）
		const interval = 50; // 更新间隔（毫秒）
		const step = (targetHeight - startHeight) / (duration / interval);

		const update = () => {
			if ((step > 0 && foundCell.BoxHeight < targetHeight) || (step < 0 && foundCell.BoxHeight > targetHeight)) {
				foundCell.BoxHeight += step;
				if ((step > 0 && foundCell.BoxHeight >= targetHeight) || (step < 0 && foundCell.BoxHeight <= targetHeight)) {
					foundCell.BoxHeight = targetHeight; // 确保最终值准确
					clearInterval(timer);
				}
			} else {
				clearInterval(timer);
			}
		};

		const timer = setInterval(update, interval);
	}
}

// 更新输送线数据的通用函数
function updateCellData(cellsData: any[], data: any) {
	const foundCell = cellsData.find(cell => cell.Code === data.stationNum);
	if (foundCell) {
		if (data.boHaveItem) {
			foundCell.IsUse = 1;
		}
		else {
			foundCell.IsUse = 0;
		}
	}
}

const activeName = ['1', '2', '3'];

//输送线数据
let cellsData = cellsDataOne.value;


// 层平面状态
const floorStates = ref({
	isPlain1: false,
	isPlain2: true,
	isPlain3: true
});
let floorNum=1;
//切换层平面
function floorTogglePlain(buttonNumber) {
	floorNum=buttonNumber;
	const floorData = [cellsDataOne.value, cellsDataTwo.value, cellsDataThree.value];
	if (buttonNumber >= 1 && buttonNumber <= 3) {
		const index = buttonNumber - 1;
		floorStates.value = {
			isPlain1: index !== 0,
			isPlain2: index !== 1,
			isPlain3: index !== 2
		};
		cellsData = floorData[index];
	}
}
</script>

<style scoped>
.box-card {
	height: 30px;
	padding: 0;
	display: flex;
	align-items: center;
	margin-top: 3px;
}

.card-page {
	width: 100%;
	height: 30px;
	display: flex;
	text-align: center;
	justify-content: center;
	align-items: center;
	text-align: center;
}

.card-page>button {
	width: 150px;
	height: 30px;
}

.card-line {
	border: none;
	background-color: transparent;
	position: absolute;
	z-index: 99;
}

.grid-container-line {
	display: grid;
	grid-template-columns: repeat(42, 1fr);
	/* 自适应列宽 */
	grid-template-rows: 1fr;
	/* 自适应行高 */
	gap: 0;
	margin-top: 25px;
	width: 100%;
	/* 宽度自适应 */
	height: 1fr;
	/* 高度自适应 */
}

.grid-item-line {
	text-align: center;
	line-height: 50px;
	/* Vertical center the content */
	font-size: 12px;
	/* Adjust font size */
	width: 30px;
	height: 100%;
	color: #fff;
	font-size: 14px;

	display: flex;
	justify-content: center;
}

.grid-item-line-end {
	width: 80px;
	height: 25px;
	border: 2px solid #797777;
	background-color: rgb(182, 180, 180);
	position: absolute;
	margin-top: -25px;
	display: flex;
	text-align: center;
	justify-content: center;
	align-items: center;
	text-align: center;
	color: #fff;
}

.grid-item-line-box {
	width: 20px;
	height: 20px;
	background-color: rgb(97, 250, 145);
	position: absolute;
	display: flex;
	text-align: center;
	justify-content: center;
	align-items: center;
	/* Added to vertically center the text */
	text-align: center;
	color: black;
}

.grid-item-line-child {
	height: 420px;
	width: 3px;
	background-color: #000000;
}
.grid-item-line-child2 {
	height: 620px;
	width: 3px;
	background-color: #000000;
}
.grid-item-line-child3{
	height: 260px;
	width: 3px;
	background-color: #000000;
}

.card {
	width: 100%;
	position: absolute;
	border-top: none;
	z-index: 90;
	margin-top: 10px;
}

.grid-container {
	width: 100%;
	display: grid;
	grid-template-columns: repeat(42, 1fr);
	/* 每列宽度 */
	grid-template-rows: repeat(17, 1fr);
	/* 每行高度 */
	gap: 0px;
	/* Gap between cells */
	margin-top: -400px
}
.grid-container2 {
	width: 100%;
	display: grid;
	grid-template-columns: repeat(42, 1fr);
	/* 每列宽度 */
	grid-template-rows: repeat(17, 1fr);
	/* 每行高度 */
	gap: 0px;
	/* Gap between cells */
	margin-top: -30px
}

.grid-item {
	background-color: #9c9c9c;
	border: 1px solid #797777;
	text-align: center;
	line-height: 1.4vw;
	/* 行高 */
	width: 100%;
	/* 自适应宽度 */
	height: 100%;
	/* 自适应高度 */
	color: #fff;
	font-size: 0.7vw;
}

.active {
	background-color: rgb(57, 141, 251);
	/* IsUse 为1时背景颜色为蓝色 */
	color: #f5f5f5;
}

.active2>div {
	display: none;
}

.active3 {
	background-color: #fff;
	border: 1px solid red;
}

.active3>div {
	display: none;
}
</style>